"""
Program to plot the evaluate and plot Harig et al (2008)'s criteria for
maximum triangle size


Creator: Jonathan Griffin
Created: 7 October 2009
"""
import os
import sys
from os.path import join

import matplotlib
matplotlib.use('Agg')
import pylab
from pylab import *
import numpy

path = r'/nas/gemd/georisk_models/inundation/data/australia_ph2/documents/250m comparisons'


figure_name = 'xmin.png'   

figure_folder = join(path, 'figures')
figure_path = join(figure_folder, figure_name)

# Constants
ct = 20.0
ch = 30.0

# Water depths to eveluate function at
h = [100,90,80,70,60,50,40,30,20,10,0]
slope = [0.001,0.005,0.01,0.05, 0.1, 0.5]
slope_dict = {0.001: 'r',0.005:'b',0.01:'r',0.05:'g', 0.1:'b', 0.5:'y'}

    

# Gravity
g = 9.81

#pylab.semilogy()
pylab.xlabel('Depth (m)')
pylab.ylabel('xmin (m)')
for sl in slope:
    xmin = []
    for depth in h:
        a = ct*numpy.sqrt(g*depth)
        print 'a', a
        b = ch*(1.0/sl)
        print 'b', b
        minval = numpy.min([a,b])
        print 'minval', minval
        xmin.append(minval)
        print 'xmin', xmin
    pylab.plot(h, xmin, color = slope_dict[sl])
    print xmin
    

pylab.savefig(figure_path)
