""" This code calculates the time differences for 250 m adn
high resolution models

Creator: Jonathan Griffin, Geoscience Australia
Created: 10 November 2009
"""

import os
import sys
from os.path import join
import csv

import matplotlib
matplotlib.use('Agg')
import pylab
from pylab import *
import numpy

path = r'/nas/gemd/georisk_models/inundation/data/'
figure_path = r'/nas/gemd/georisk_models/inundation/data/australia_ph2/documents/250m comparisons/figures'
figure_name = 'Phase2_velocity_comp.png'

plot = 'percent'
#plot = 'absolute'
#plot = 'high_res'
figure_file_path = figure_path + '/'+plot + '_' +figure_name

PHed1 = r'/nas/gemd/georisk_models/inundation/data/western_australia/pt_hedland_tsunami_scenario_2009/anuga/outputs/20081125_135917_run_final_0_27283_250m_none_lfountai'
PHed2 = r'/nas/gemd/georisk_models/inundation/data/western_australia/pt_hedland_tsunami_scenario_2009/anuga/outputs/20081211_095614_run_final_0.0_27283_alpha0.1_jgriffin'
Bus1 = r'/nas/gemd/georisk_models/inundation/data/western_australia/busselton_tsunami_scenario/anuga/outputs/20091210_133449_run_final_0.6_27255_Bt_250m_jgriffin'
Bus2 = r'/nas/gemd/georisk_models/inundation/data/western_australia/busselton_tsunami_scenario/anuga/outputs/20090403_092302_run_final_0.6_27255_Bt_kvanputt'
Car1 = r'/nas/gemd/georisk_models/inundation/data/western_australia/carnarvon_tsunami_scenario/anuga/outputs/20100112_172321_run_final_0_27255_250m_jgriffin'
Car2 = r'/nas/gemd/georisk_models/inundation/data/western_australia/carnarvon_tsunami_scenario/anuga/outputs/20090327_154824_run_final_0_27255_Bt_kvanputt'
Ger1 = r'/nas/gemd/georisk_models/inundation/data/western_australia/geraldton_tsunami_scenario/anuga/outputs/20091210_174442_run_final_0_27255_Bt_250m_jgriffin'
Ger2 = r'/nas/gemd/georisk_models/inundation/data/western_australia/geraldton_tsunami_scenario/anuga/outputs/20090327_160043_run_final_0_27255_Bt_kvanputt'

Gos1 = r'/nas/gemd/georisk_models/inundation/data/new_south_wales/gosford_tsunami_scenario_2009/anuga/outputs/20090915_094930_run_final_0.0_51436_250m_jgriffin'
Gos2 = r'/nas/gemd/georisk_models/inundation/data/new_south_wales/gosford_tsunami_scenario_2009/anuga/outputs/20090615_160610_run_final_0.0_51436_jgriffin'
BBay1 = r'/nas/gemd/georisk_models/inundation/data/new_south_wales/batemans_bay_tsunami_scenario_2009/anuga/outputs/20090601_172248_run_final_0.0_58284__250m_jgriffin'
BBay2 = r'/nas/gemd/georisk_models/inundation/data/new_south_wales/batemans_bay_tsunami_scenario_2009/anuga/outputs/20090520_145616_run_final_0.0_58284_jgriffin'
Gold1 =r'/nas/gemd/georisk_models/inundation/data/queensland/gold_coast_tsunami_scenario_2009/anuga/outputs/20090605_120328_run_final_0_250m_51469_lfountai'
Gold2 =r'/nas/gemd/georisk_models/inundation/data/queensland/gold_coast_tsunami_scenario_2009/anuga/outputs/20090508_150215_run_final_0_51469_lfountai'
Hob1 = r'/nas/gemd/georisk_models/inundation/data/tasmania/hobart_tsunami_scenario_2009/anuga/outputs/20090930_151227_run_final_0_58260_250m_jgriffin'
Hob2 = r'/nas/gemd/georisk_models/inundation/data/tasmania/hobart_tsunami_scenario_2009/anuga/outputs/20090714_162136_run_final_0_58260_None_kvanputt'

low_res_list = [PHed1, Bus1, Car1, Ger1, Gos1, BBay1, Gold1, Hob1]
high_res_list = [PHed2, Bus2, Car2, Ger2, Gos2, BBay2, Gold2, Hob2]
depth_list = [0,-10,-20,-30,-40,-50]

depth_list2 = [-60,-50,-40,-30,-20,-10,0,10]
twenty_m = [20,20,20,20,20,20,20,20]

marker_list = ['x','^', 'x', '+', 'x','^', 'x', '+' ]
colours = ['b','b','b','b','r','r','r','r']


for i in range(len(low_res_list)):
    low_res_vel_list = []
    high_res_vel_list = []
    for depth in depth_list:
        file_path = low_res_list[i]+'/gauge_'+str(depth)+'.csv'
        reader = csv.reader(open(file_path))
        header = reader.next()
        initial_values = reader.next()
        velocity_values = []
        for row in reader:
            velocity_values.append(float(row[3]))
        max_velocity_low_res = np.max(velocity_values)
        low_res_vel_list.append(max_velocity_low_res)
            
    for depth in depth_list:
        file_path = high_res_list[i]+'/gauge_'+str(depth)+'.csv'
        reader = csv.reader(open(file_path))
        header = reader.next()
        initial_values = reader.next()
        velocity_values = []
        for row in reader:
            velocity_values.append(float(row[3]))
        max_velocity_high_res = np.max(velocity_values)
        high_res_vel_list.append(max_velocity_high_res)
        
    vel_diff = []
    vel_percent_diff = []
    for j in range(len(low_res_vel_list)):
        if high_res_vel_list[j] ==0:
            high_res_vel_list[j]=-999999
        if low_res_vel_list[j] ==0:
            low_res_vel_list[j]=999999
        vel_diff.append(abs((high_res_vel_list[j] - low_res_vel_list[j])))
        vel_percent_diff.append(100*vel_diff[j]/high_res_vel_list[j])

    print 'velocity_diff', vel_diff
    print 'velocity_percent_diff', vel_percent_diff    

    

    if plot == 'percent':
        pylab.scatter(depth_list,vel_percent_diff, marker = marker_list[i], color = colours[i])
        pylab.plot(depth_list2,twenty_m, color = 'black')
#pylab.semilogy([0,1])

    if plot == 'absolute':
        pylab.scatter(depth_list,vel_diff, marker = marker_list[i], color = colours[i])

    if plot == 'high_res':
        pylab.scatter(depth_list,high_res_vel_list, marker = marker_list[i], color = colours[i])

if plot == 'percent':
    pylab.semilogy([-60,10,0,1000])
    pylab.axis([-60,10,0,1000])
    pylab.title('Percentage difference in maximum velocity')
    pylab.ylabel('Difference (%)')
    pylab.xlabel('Depth (m)')
    pylab.text(-58, 700, 'East Coast', color = 'r')
    pylab.text(-58, 500, 'West Coast', color = 'b')
    pylab.text(-58, 22, '20%')
    
    
if plot == 'absolute':
    
    pylab.axis([-60,10,0,5])
    pylab.title('Difference in maximum velocity (m/s)')
    pylab.ylabel('Difference (m/s)')
    pylab.xlabel('Depth (m)')
    pylab.text(-58, 4.7, 'East Coast', color = 'r')
    pylab.text(-58, 4.5, 'West Coast', color = 'b')


if plot == 'high_res':
    
    pylab.axis([-60,10,0,10])
    pylab.title('Maximum velocity (m/s)')
    pylab.ylabel('Velocity (m/s)')
    pylab.xlabel('Depth (m)')
    pylab.text(-58, 4.7, 'East Coast', color = 'r')
    pylab.text(-58, 4.5, 'West Coast', color = 'b')
  
pylab.savefig(figure_file_path)
