"""
Generate time series of nominated "gauges".
Input: sww file from run_perth.py
       gauges project.gauge_filename
Output: csv files stage,speed,depth,elevation over time
Stored in the 'outputs_dir' folder for respective .sww file

Note:
Can run different sww files at the same time
make sure if there is a second sww file that it is placed into a folder called sww2
Can run different gauges at the same time - ie testing boundary index point
"""

from os import sep, rename, listdir, system
from anuga.abstract_2d_finite_volumes.util import sww2csv_gauges,csv2timeseries_graphs
import project

directory = project.output_folder

time_dir1 = '20090331_150428_run_final_0_58152_2956_Tb_lfountai'
time_dir2 = '20090331_150758_run_final_0_58152_2956_Bf_lfountai'
##time_dir3 = ''
##time_dir4 = ''
##time_dir5 = ''
##time_dir6 = ''
##
##time_dirs = [time_dir1, time_dir2, time_dir3, time_dir4, time_dir5, time_dir6]

##time_dir1 = '20081217_115336_run_final_0_27283_250m_none_dp_kvanputt'
##time_dir6 = '20090311_145740_run_final_0_58152_2956_Tb_jgriffin'

time_dirs = [time_dir2]

for time_dir in time_dirs:
    name = directory+sep+time_dir+sep+project.scenario_name 
    gauge = project.gauges
    sww2csv_gauges(name+'.sww',gauge,
                   quantities = ['stage','speed','depth','elevation'],
                   verbose=True)
  

